Option Explicit
Class RegistryCls

' Registry access utilities.  All functions should be accessed as methods of the 
' global Registry object (e.g. Registry.Regvar(...)).  The Registry object is 
' created and initialized automatically on script load.


'-------------------
' Class boilerplate
'-------------------

Public tef

Private Sub Class_Initialize()
	Call TraceEnter("Registry.Initialize", "")
	
	Set shell = CreateObject("WScript.Shell")
	
	Set dictSzRegvar = CreateObject("Scripting.Dictionary")
	dictSzRegvar.CompareMode = vbTextCompare
	
	Call TraceExit("Registry.Initialize", "")
End Sub

Private Sub Class_Terminate()
	Call TraceEnter("Registry.Terminate", "")
	
	Call TraceExit("Registry.Terminate", "")
End Sub


'---------
' Methods
'---------

' Create a registry variable object for a specific registry entry.  szKey is 
' the fully qualified registry path string to the variable in question.  If 
' the value doesn't yet exist, initialize it using the given default value.
Public Function Regvar(szKey, vDefault)
	Call TraceEnter("Registry.Regvar", SzQuote(szKey))
	
	If dictSzRegvar.Exists(szKey) Then
		Set Regvar = dictSzRegvar(szKey)
	Else
		Set Regvar = RegvarNew()
		Call Regvar.Create(shell, _
		  "HKEY_CURRENT_USER\Software\VB and VBA Program Settings\SkunkWare\" + szKey, _
		  vDefault)
		Set dictSzRegvar(szKey) = Regvar
	End If
	
	Call TraceExit("Registry.Regvar", "")
End Function


'----------
' Privates
'----------

Private shell			' WSH Shell object.
Private dictSzRegvar	' Dictionary of outstanding registry variables.


End Class


' Instantiate the global object.
Public Registry
Set Registry = New RegistryCls


