Option Explicit
Class RegvarCls

' Registry variable object.  This is a multi-use class, each instance of which 
' represents a single registry variable.


'---------
' Publics
'---------

' Initialize this object from the given parameters.  Shell is a reference to a 
' WSH Shell object used to access the registry.  szKey is the fully qualified 
' registry path string to this varible.  vDefault is the default value.
Public Function Create(shell, szKey, vDefault)
	
	Set shellMbr = shell
	szKeyMbr = szKey
	vMbr = vDefault
	
'	Try to read the value from the registry.
	On Error Resume Next
	vMbr = shellMbr.RegRead(szKeyMbr)
	On Error Goto 0
	
End Function

' Return the current value of this registry variable.
Public Property Get val()
	val = vMbr
End Property

' Set the value of this registry variable.
Public Property Let val(vNew)
	vMbr = vNew
	Call shellMbr.RegWrite(szKeyMbr, vNew)
End Property


'----------
' Privates
'----------

Private shellMbr		' WSH Shell object for registry access.
Private szKeyMbr		' Full path to this variable.
Private vMbr			' Current value.


End Class


' Instantiator function.
Public Function RegvarNew()
	Set RegvarNew = New RegvarCls
End Function


